package com.itsoulos.jsonviewer;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import org.json.JSONArray;
import org.json.JSONException;
import org.w3c.dom.Text;


public class JsonAdapter extends ArrayAdapter {
    Context context=null;
    JSONArray data=new JSONArray();
    Bitmap bm=null;

    public JsonAdapter( Context ctx, JSONArray d)
    {
        super(ctx,0);
        data=d;
        context=ctx;
    }

    public int getCount()
    {
        return data.length()+1;//plus 1 for the header
    }

    public View getView(int position, View convertView, ViewGroup parent) {
        LinearLayout l=new LinearLayout(context);
        l.setOrientation(LinearLayout.HORIZONTAL);
        TextView nameText=new TextView(context);
        l.addView(nameText);
        TextView depText=new TextView(context);
        l.addView(depText);
        TextView salaryText=new TextView(context);
        l.addView(salaryText);

        ImageView im=null;
        if(position==0)
        {
            nameText.setText("LASTNAME");
            depText.setText("DEPARTMENT");
            salaryText.setText("SALARY");
            salaryText.setTextColor(Color.LTGRAY);
            depText.setTextColor(Color.LTGRAY);
            nameText.setTextColor(Color.LTGRAY);
        }
        else
        {
            im=new ImageView(context);
            l.addView(im);
            if(bm==null) {
                bm = BitmapFactory.decodeResource(context.getResources(), R.drawable.rightarrow);
                double ratio = bm.getWidth() * 1.0 / bm.getHeight();
                int newHeight = 6 * Global.height / 100;
                int newWidth = (int) (ratio * newHeight);
                bm = bm.createScaledBitmap(bm, newWidth, newHeight, true);
            }
            im.setImageBitmap(bm);

            try {
                nameText.setText(data.getJSONObject(position-1).getString("lastname"));
                depText.setText(data.getJSONObject(position-1).getString("department"));
                salaryText.setText(""+data.getJSONObject(position-1).getDouble("salary"));
                salaryText.setTextColor(Color.BLACK);
                depText.setTextColor(Color.BLACK);
                nameText.setTextColor(Color.BLACK);
            } catch (JSONException e) {
                e.printStackTrace();
            }
        }

        LinearLayout.LayoutParams t1params=(LinearLayout.LayoutParams)nameText.getLayoutParams();
        t1params.leftMargin=5 * Global.width/100;
        t1params.topMargin=1 * Global.height/100;
        t1params.height= 2 * t1params.topMargin+6 * Global.height/100;
        t1params.width=20 * Global.width/100;
        t1params.gravity= Gravity.CENTER_VERTICAL;
        nameText.setLayoutParams(t1params);
        depText.setLayoutParams(t1params);
        salaryText.setLayoutParams(t1params);
        salaryText.setGravity(Gravity.RIGHT);

        if(im!=null) {
            LinearLayout.LayoutParams iparams = (LinearLayout.LayoutParams) im.getLayoutParams();
            iparams.rightMargin = t1params.leftMargin;
            iparams.width = bm.getWidth();
            iparams.height = t1params.height;
            iparams.leftMargin = Global.width - 3 * t1params.leftMargin - 3 * t1params.width - iparams.width - iparams.rightMargin;
            im.setLayoutParams(iparams);
        }
        return l;
    }
}
