package com.itsoulos.jsonviewer;

import androidx.appcompat.app.AppCompatActivity;

import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

public class MainActivity extends AppCompatActivity {

    JSONArray data=new JSONArray();
    LinearLayout mainLayout=null;
    ListView listView=null;
    TextView result=null;

    void makeArray()
    {
        try {
            JSONObject x=new JSONObject();

            x.put("lastname","Pappas");
            x.put("department","dep1");
            x.put("salary",1000);
            data.put(x);

            JSONObject y=new JSONObject();
            y.put("lastname","Ioannou");
            y.put("department","dep2");
            y.put("salary",1200);
            data.put(y);

            JSONObject z=new JSONObject();
            z.put("lastname","Dimitriou");
            z.put("department","dep1");
            z.put("salary",800);
            data.put(z);

            JSONObject w=new JSONObject();
            w.put("lastname","Xristou");
            w.put("department","dep2");
            w.put("salary",700);
            data.put(w);

        } catch (JSONException e) {
            e.printStackTrace();
        }

    }
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        mainLayout=new LinearLayout(this);
        mainLayout.setOrientation(LinearLayout.VERTICAL);
        setContentView(mainLayout);
        Global.getDimensions(this);

        result=new TextView(this);
        result.setTextColor(Color.WHITE);
        result.setTextSize(20);
        result.setBackgroundColor(Color.BLACK);
        mainLayout.addView(result);

        makeArray();

        listView=new ListView(this);
        mainLayout.addView(listView);
        listView.setAdapter(new JsonAdapter(this,data));

        LinearLayout.LayoutParams rparams=(LinearLayout.LayoutParams)result.getLayoutParams();
        rparams.leftMargin=5 * Global.width/100;
        rparams.width=90 * Global.width/100;
        rparams.height=8 * Global.height/100;
        rparams.topMargin=2 * Global.height/100;
        rparams.bottomMargin=2 * Global.height/100;
        result.setLayoutParams(rparams);

        listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                if(position!=0)
                {
                    try {
                        JSONObject xx=data.getJSONObject(position-1);
                        result.setText("SELECTED "+xx);
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }
                }
            }
        });

    }
}
